## ros-melodic-octovis 1.9.0

=== debian/changelog ===
ros-melodic-octovis (1.9.0-1stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Armin Hornung <armin@hornung.io>  Mon, 02 Apr 2018 18:54:18 -0000
