=== debian/control ===
Source: ros-melodic-octovis
Section: misc
Priority: extra
Maintainer: Armin Hornung <armin@hornung.io>
Build-Depends: debhelper (>= 9.0.0), cmake, libqglviewer-dev-qt4, libqt4-dev, libqt4-opengl-dev, ros-melodic-octomap
Homepage: http://octomap.github.io
Standards-Version: 3.9.2

Package: ros-melodic-octovis
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqglviewer2-qt4, libqt4-opengl, libqtgui4, ros-melodic-catkin, ros-melodic-octomap
Description: octovis is visualization tool for the OctoMap library based on Qt and libQGLViewer.
 See http://octomap.github.io for details.
