## ros-melodic-octovis 1.9.8

=== debian/changelog ===
ros-melodic-octovis (1.9.8-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Armin Hornung <armin@hornung.io>  Fri, 13 May 2022 15:44:03 -0000
